package org.xbib.event.async;

/**
 * A closeable resource.
 * <p/>
 * This interface is mostly used for internal resource management.
 */
public interface Closeable {

  /**
   * Close this resource, the {@code completion} promise must be notified when the operation has completed.
   *
   * @param completion the promise to signal when close has completed
   */
  void close(Promise<Void> completion);
}
