package org.xbib.event.async.impl.future;

import org.xbib.event.async.impl.ContextInternal;

import java.util.function.Function;

/**
 * Function map transformation.
 */
class Mapping<T, U> extends Operation<U> implements Listener<T> {

  private final Function<T, U> successMapper;

  Mapping(ContextInternal context, Function<T, U> successMapper) {
    super(context);
    this.successMapper = successMapper;
  }

  @Override
  public void onSuccess(T value) {
    U result;
    try {
      result = successMapper.apply(value);
    } catch (Throwable e) {
      tryFail(e);
      return;
    }
    tryComplete(result);
  }

  @Override
  public void onFailure(Throwable failure) {
    tryFail(failure);
  }
}
