package org.xbib.event.async.yield.async;

import org.xbib.event.async.yield.AsyncQuery;
import org.xbib.event.async.yield.AsyncTraverser;

import java.util.concurrent.CompletableFuture;
import java.util.function.BiConsumer;

public class AsyncQuerySkip<T> extends AsyncQuery<T> {

    private final AsyncTraverser<T> upstream;

    private final int skip;

    private int count = 0;

    public AsyncQuerySkip(AsyncTraverser<T> upstream, int skip) {
        this.upstream = upstream;
        this.skip = skip;
    }

    @Override
    public CompletableFuture<Void> subscribe(BiConsumer<? super T, ? super Throwable> cons) {
        return upstream.subscribe((item, err) -> {
            if (err != null) {
                cons.accept(null, err);
                return;
            }
            if (count >= skip) cons.accept(item, err);
            else count++;
        });
    }
}
