package org.xbib.event.async.yield.ops;

import org.xbib.event.async.yield.Advancer;
import org.xbib.event.async.yield.Query;
import org.xbib.event.async.yield.Traverser;
import org.xbib.event.async.yield.Yield;
import org.xbib.event.async.yield.boxes.BoolBox;

import java.util.HashSet;

public class Distinct<T> implements Advancer<T>, Traverser<T> {

    final HashSet<T> mem = new HashSet<>();
    private final Query<T> upstream;

    public Distinct(Query<T> adv) {
        this.upstream = adv;
    }

    @Override
    public void traverse(Yield<? super T> yield) {
        upstream.traverse(item -> {
            if (mem.add(item)) yield.ret(item);
        });
    }

    @Override
    public boolean tryAdvance(Yield<? super T> yield) {
        final BoolBox found = new BoolBox();
        while (found.isFalse() && upstream.tryAdvance(item -> {
            if (mem.add(item)) {
                yield.ret(item);
                found.set();
            }
        })) ;
        return found.isTrue();
    }
}
