package org.xbib.event.async.yield.ops;

import org.xbib.event.async.yield.Advancer;
import org.xbib.event.async.yield.Query;
import org.xbib.event.async.yield.Traverser;
import org.xbib.event.async.yield.Yield;

public class Limit<T> implements Advancer<T>, Traverser<T> {

    private final Query<T> upstream;

    private final int n;

    int count;

    public Limit(Query<T> upstream, int n) {
        this.upstream = upstream;
        this.n = n;
        count = 0;
    }

    @Override
    public boolean tryAdvance(Yield<? super T> yield) {
        if (count >= n) return false;
        count++;
        return upstream.tryAdvance(yield);

    }

    @Override
    public void traverse(Yield<? super T> yield) {
        if (count >= n)
            throw new IllegalStateException("Traverser has already been operated on or closed!");
        while (this.tryAdvance(yield)) {
            // Intentionally empty. Action specified on yield statement of tryAdvance().
        }
    }
}
