package org.xbib.event.async.yield.ops;

import org.xbib.event.async.yield.Advancer;
import org.xbib.event.async.yield.Query;
import org.xbib.event.async.yield.Traverser;
import org.xbib.event.async.yield.Yield;
import org.xbib.event.async.yield.boxes.BoolBox;

import java.util.function.BiFunction;

public class Zip<T, U, R> implements Advancer<R>, Traverser<R> {

    private final Query<T> upstream;

    private final Query<U> other;

    private final BiFunction<? super T, ? super U, ? extends R> zipper;

    public Zip(Query<T> upstream, Query<U> other, BiFunction<? super T, ? super U, ? extends R> zipper) {
        this.upstream = upstream;
        this.other = other;
        this.zipper = zipper;
    }

    @Override
    public boolean tryAdvance(Yield<? super R> yield) {
        BoolBox consumed = new BoolBox();
        upstream.tryAdvance(e1 -> other.tryAdvance(e2 -> {
            yield.ret(zipper.apply(e1, e2));
            consumed.set();
        }));
        return consumed.isTrue();
    }


    @Override
    public void traverse(Yield<? super R> yield) {
        upstream.shortCircuit(e1 -> {
            if (!other.tryAdvance(e2 -> yield.ret(zipper.apply(e1, e2))))
                Yield.bye();
        });
    }
}
