package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.boxes.BoolBox;
import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleQuery;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

import java.util.HashSet;

public class DoubleDistinct implements DoubleAdvancer, DoubleTraverser {

    final HashSet<Double> mem = new HashSet<>();

    private final DoubleQuery upstream;

    public DoubleDistinct(DoubleQuery adv) {
        this.upstream = adv;
    }

    @Override
    public void traverse(DoubleYield yield) {
        upstream.traverse(item -> {
            if (mem.add(item)) {
                yield.ret(item);
            }
        });
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        final BoolBox found = new BoolBox();
        while (found.isFalse() && upstream.tryAdvance(item -> {
            if (mem.add(item)) {
                yield.ret(item);
                found.set();
            }
        })) ;
        return found.isTrue();
    }
}
