package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.boxes.BoolBox;
import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleQuery;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

import java.util.function.DoublePredicate;

public class DoubleFilter implements DoubleAdvancer, DoubleTraverser {

    private final DoubleQuery upstream;

    private final DoublePredicate p;

    public DoubleFilter(DoubleQuery adv, DoublePredicate p) {
        this.upstream = adv;
        this.p = p;
    }

    @Override
    public void traverse(DoubleYield yield) {
        upstream.traverse(e -> {
            if (p.test(e)) {
                yield.ret(e);
            }
        });
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        BoolBox found = new BoolBox();
        while (found.isFalse()) {
            boolean hasNext = upstream.tryAdvance(item -> {
                if (p.test(item)) {
                    yield.ret(item);
                    found.set();
                }
            });
            if (!hasNext) break;
        }
        return found.isTrue();
    }
}
