package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

import java.util.function.DoubleSupplier;

public class DoubleGenerate implements DoubleAdvancer, DoubleTraverser {
    private final DoubleSupplier s;

    public DoubleGenerate(DoubleSupplier s) {
        this.s = s;
    }

    @Override
    public void traverse(DoubleYield yield) {
        while (true) {
            yield.ret(s.getAsDouble());
        }
    }


    @Override
    public boolean tryAdvance(DoubleYield yield) {
        yield.ret(s.getAsDouble());
        return true;
    }
}
