package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.Advancer;
import org.xbib.event.async.yield.Traverser;
import org.xbib.event.async.yield.Yield;
import org.xbib.event.async.yield.primitives.dbl.DoubleQuery;

import java.util.function.DoubleFunction;

public class DoubleMapToObj<T> implements Advancer<T>, Traverser<T> {

    private final DoubleQuery upstream;

    private final DoubleFunction<? extends T> mapper;

    public DoubleMapToObj(DoubleQuery adv, DoubleFunction<? extends T> mapper) {
        this.upstream = adv;
        this.mapper = mapper;
    }

    @Override
    public void traverse(Yield<? super T> yield) {
        upstream.traverse(e -> yield.ret(mapper.apply(e)));
    }

    @Override
    public boolean tryAdvance(Yield<? super T> yield) {
        return upstream.tryAdvance(item -> yield.ret(mapper.apply(item)));
    }
}
