package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

public class FromDoubleArray implements DoubleAdvancer, DoubleTraverser {

    private final double[] data;

    private int current;

    public FromDoubleArray(double... data) {
        this.data = data;
        this.current = 0;
    }

    public boolean hasNext() {
        return current < data.length;
    }

    /**
     * Continues from the point where tryAdvance or next left the
     * internal iteration.
     *
     * @param yield yield
     */
    @Override
    public void traverse(DoubleYield yield) {
        for (int i = current; i < data.length; i++) {
            yield.ret(data[i]);
        }
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        if (!hasNext()) return false;
        yield.ret(data[current++]);
        return true;
    }
}
