package org.xbib.event.async.yield.primitives.intgr.ops;

import org.xbib.event.async.yield.Advancer;
import org.xbib.event.async.yield.Traverser;
import org.xbib.event.async.yield.Yield;
import org.xbib.event.async.yield.primitives.intgr.IntQuery;

import java.util.function.IntFunction;

public class IntMapToObj<T> implements Advancer<T>, Traverser<T> {

    private final IntQuery upstream;
    private final IntFunction<? extends T> mapper;

    public IntMapToObj(IntQuery adv, IntFunction<? extends T> mapper) {
        this.upstream = adv;
        this.mapper = mapper;
    }

    @Override
    public void traverse(Yield<? super T> yield) {
        upstream.traverse(e -> yield.ret(mapper.apply(e)));
    }

    @Override
    public boolean tryAdvance(Yield<? super T> yield) {
        return upstream.tryAdvance(item -> yield.ret(mapper.apply(item)));
    }
}
