package org.xbib.event.async.yield.primitives.intgr.ops;

import org.xbib.event.async.yield.primitives.intgr.IntAdvancer;
import org.xbib.event.async.yield.primitives.intgr.IntQuery;
import org.xbib.event.async.yield.primitives.intgr.IntTraverser;
import org.xbib.event.async.yield.primitives.intgr.IntYield;

public class IntSkip implements IntAdvancer, IntTraverser {

    private final IntQuery upstream;

    private final int n;

    int index;

    public IntSkip(IntQuery adv, int n) {
        this.upstream = adv;
        this.n = n;
        index = 0;
    }

    /**
     * Continues from the point where tryAdvance or next left the
     * internal iteration.
     *
     * @param yield
     */
    @Override
    public void traverse(IntYield yield) {
        upstream.traverse(item -> {
            if (index++ >= n) {
                yield.ret(item);
            }
        });
    }

    @Override
    public boolean tryAdvance(IntYield yield) {
        for (; index < n; index++)
            upstream.tryAdvance(item -> {
            });
        return upstream.tryAdvance(yield);
    }
}
