package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongQuery;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

public class LongConcat implements LongAdvancer, LongTraverser {
    private final LongQuery first;
    private final LongQuery second;

    public LongConcat(LongQuery first, LongQuery second) {
        this.first = first;
        this.second = second;
    }

    @Override
    public void traverse(LongYield yield) {
        this.first.traverse(yield);
        this.second.traverse(yield);
    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        return first.tryAdvance(yield) || second.tryAdvance(yield);
    }
}
