package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

import java.util.function.LongSupplier;

public class LongGenerate implements LongAdvancer, LongTraverser {
    private final LongSupplier s;

    public LongGenerate(LongSupplier s) {
        this.s = s;
    }

    @Override
    public void traverse(LongYield yield) {
        while (true) {
            yield.ret(s.getAsLong());
        }
    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        yield.ret(s.getAsLong());
        return true;
    }
}
