package org.xbib.event.wal;

/**
 * <p>
 * Enumerates the valid types of things that can cause a
 * {@link WriteAheadRepository} to update its state</p>
 */
public enum UpdateType {

    /**
     * Used when a new Record has been created
     */
    CREATE,
    /**
     * Used when a Record has been updated in some way
     */
    UPDATE,
    /**
     * Used to indicate that a Record has been deleted and should be removed
     * from the Repository
     */
    DELETE,
    /**
     * Used to indicate that a Record still exists but has been moved elsewhere,
     * so that it is no longer maintained by the WALI instance
     */
    SWAP_OUT,
    /**
     * Used to indicate that a Record that was previously Swapped Out is now
     * being Swapped In
     */
    SWAP_IN;
}
