package org.xbib.event.pubsub;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Queue;
import java.util.concurrent.LinkedBlockingQueue;

public class Topic<E> {

    private final String name;

    private final Queue<E> queue;

    private final Collection<Subscriber<E>> subscribers;

    public Topic(String name) {
        this.name = name;
        this.queue = new LinkedBlockingQueue<>();
        this.subscribers = new ArrayList<>();
    }

    public String getName() {
        return name;
    }

    public Queue<E> getQueue() {
        return queue;
    }

    public Collection<Subscriber<E>> getSubscribers() {
        return subscribers;
    }

    public void add(Subscriber<E> subscriber) {
        subscribers.add(subscriber);
    }

    public void remove(Subscriber<E> subscriber) {
        subscribers.remove(subscriber);
    }

    public void add(E event) {
        queue.add(event);
    }

}
